const std    = @import("std");
const dvui   = @import("dvui");
const hncore = @import("hncore");

const ui = @import("./ui.zig");

///
pub const App = struct {
    ///
    project: hncore.Project,

    ///
    pub fn init(alloc: std.mem.Allocator) !App {
        return App {
            .project = try .init(alloc),
        };
    }
    ///
    pub fn deinit(self: *App) void {
        self.project.deinit();
    }

    ///
    pub fn gui(self: *App) !void {
        try self.guiMenu();
        try self.guiMain();
    }
    fn guiMenu(self: *@This()) !void {
        _ = self;

        var root = try dvui.menu(@src(), .horizontal, .{ .background = true, .expand = .horizontal });
        defer root.deinit();

        if (try dvui.menuItemLabel(@src(), "File", .{ .submenu = true }, .{})) |r| {
            var float = try dvui.floatingMenu(
                @src(), .{.from = dvui.Rect.fromPoint(dvui.Point{ .x = r.x, .y = r.y + r.h })}, .{});
            defer float.deinit();

            if (try dvui.menuItemLabel(@src(), "Open", .{}, .{})) |_| {
            }
        }
    }
    fn guiMain(self: *@This()) !void {
        var overlay = try dvui.overlay(@src(), .{
            .expand     = .both,
            .padding    = dvui.Rect.all(8),
            .color_fill = .{ .name = .fill_window },
            .background = true,
        });
        defer overlay.deinit();

        try ui.manipulator(self.project.mindmap.root, &self.project.mindmap.digraph);
    }
};
